summaryrefslogtreecommitdiff
path: root/utils/hooks
diff options
context:
space:
mode:
authorLaurent Pinchart <laurent.pinchart@ideasonboard.com>2020-03-26 13:48:18 +0200
committerLaurent Pinchart <laurent.pinchart@ideasonboard.com>2020-04-15 01:07:42 +0300
commit36ad4eb188e078c9ec577213872febae57185646 (patch)
treeb84de9766f5601f44777a6dfa90dda10ce5b7781 /utils/hooks
parentbac0e7d6759c1fc74ab5fb0dc0cb2b561cf0f63a (diff)
utils: hooks: Add pre-push commit hook
Add a pre-push commit hooks to prevent unintentional push of patches containing local changelogs to the master branch. Signed-off-by: Laurent Pinchart <laurent.pinchart@ideasonboard.com> Reviewed-by: Niklas Söderlund <niklas.soderlund@ragnatech.se>
Diffstat (limited to 'utils/hooks')
-rwxr-xr-xutils/hooks/pre-push43
1 files changed, 43 insertions, 0 deletions
diff --git a/utils/hooks/pre-push b/utils/hooks/pre-push
new file mode 100755
index 00000000..099441b8
--- /dev/null
+++ b/utils/hooks/pre-push
@@ -0,0 +1,43 @@
+#!/bin/sh
+
+# A hook script to prevent pushing unsuitable commits to the master branch.
+# Unsuitable commits are commits that contain a local changelog below a '---'
+# line. The criteria may get extended later.
+#
+# Information about the commits which are being pushed is supplied as lines to
+# the standard input in the form:
+#
+# <local ref> <local sha1> <remote ref> <remote sha1>
+
+z40=0000000000000000000000000000000000000000
+
+while read -r local_ref local_sha remote_ref remote_sha
+do
+ if [ "$remote_ref" != refs/heads/master ]
+ then
+ continue
+ fi
+
+ # The remote master branch should never get deleted by this push, so we
+ # can assume that local_sha is not 0's. We may however be creating the
+ # remote branch, when pushing to a new empty repository for instance.
+ if [ "$remote_sha" = $z40 ]
+ then
+ # New branch, examine all commits
+ range="$local_sha"
+ else
+ # Update to existing branch, examine new commits
+ range="$remote_sha..$local_sha"
+ fi
+
+ # Find invalid commits.
+ commit=$(git rev-list -n 1 --grep '^---' "$range")
+ if [ -n "$commit" ]
+ then
+ echo >&2 "Found local changelog in $local_ref, not pushing"
+ echo >&2 "Check commit $commit"
+ exit 1
+ fi
+done
+
+exit 0